mod Ex07b

incl Mtex

incl Mauxb

loc rem 
  \para \bf  7. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 28.3.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie pomocnych funkcii 
         a predikatov. 
   \item \para Subor(y) \it  ex08*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Search Trees.  \end 

rem 
  \para \bf  Binary search trees.  \end 

pred/2 Lt 'Tex2_prec'
  Lt(x,t) <-> \a y(Inbt(y,t) -> x < y)

pred/2 Gt 'Tex2_succ'
  Gt(x,t) <-> \a y(Inbt(y,t) -> x > y)

pred Bst 
  Bst(t) <-> Bt(t) & \a x\a l\a r(Subtree(Nd(x,l,r),t) -> Gt(x,l) & Lt(x,r))

rem 
  \para \bf  Membership in binary search trees.  \end 
  \header* pred/2 Inbst 'Tex_p2_set_member' \end Define the predicate 
  \ft Inbst(x,t) \end such that 
  \eq* 
    Bst(t) -> Inbst(x,t) <-> Inbt(x,t)
  \end

pred/2 Inbst 'Tex_p2_set_member'
  Inbst(x,t) <-> Poo

rem 
  \para \bf  Minimal element in a binary search tree.  \end Define the function 
  \ft Min(t) \end such that 
  \eq* 
    Bst(t) & t != E -> Inbt(Min(t),t)
  \end
  \eq* 
    Bst(t) & t != E & Inbt(x,t) -> Min(t) <= x
  \end

fun Min 
  Min(t) = Foo

rem 
  \para \bf  Maximal element in a binary search tree.  \end Define the function 
  \ft Max(t) \end such that 
  \eq* 
    Bst(t) & t != E -> Inbt(Max(t),t)
  \end
  \eq* 
    Bst(t) & t != E & Inbt(x,t) -> x <= Max(t)
  \end

fun Max 
  Max(t) = Foo

rem 
  \para \bf  Deletion of the minimal element in a binary search tree.  \end 
  Define the function \ft Delmin(t) \end such that 
  \eq* 
    Bst(t) & t != E -> Inbt(x,Delmin(t)) <-> Inbt(x,t) & x != Min(t)
  \end
  \eq* 
    Bst(t) & t != E -> Bst Delmin(t)
  \end

fun Delmin 
  Delmin(t) = Foo

rem 
  \para \bf  Deletion of the maximal element in a binary search tree.  \end 
  Define the function \ft Delmax(t) \end such that 
  \eq* 
    Bst(t) & t != E -> Inbt(x,Delmax(t)) <-> Inbt(x,t) & x != Max(t)
  \end
  \eq* 
    Bst(t) & t != E -> Bst Delmax(t)
  \end

fun Delmax 
  Delmax(t) = Foo

rem 
  \para \bf  Insertion in binary search trees.  \end 
  \header* fun/2 Insert 'Tex_f2_set_insert' \end Define the function 
  \ft Insert(t,x) \end such that 
  \eq* 
    Bst(t) -> Inbt(y,Insert(t,x)) <-> Inbt(y,t) \/ y = x
  \end
  \eq* 
    Bst(t) -> Bst Insert(t,x)
  \end

fun/2 Insert 'Tex_f2_set_insert'
  Insert(t,x) = Foo

rem 
  \para \bf  Join of two binary search trees.  \end 
  \header* fun/2 Join 'Tex2_sqcup' \end \header* pred/2 Ltb 'Tex_p2_bt_ltb' \end 
  Define the function \ft Join(t1,t2) \end such that 
  \eq* 
    Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Inbt(x,Join(t1,t2)) <-> 
    Inbt(x,t1) \/ Inbt(x,t2)
  \end
  \eq* 
    Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Bst Join(t1,t2)
  \end
  \para where 
  \eq* 
    Ltb(t1,t2) <-> \a x1\a x2(Inbt(x1,t1) & Inbt(x2,t2) -> x1 < x2)
  \end

fun/2 Join 'Tex2_sqcup'
  Join(t1,t2) = Foo

rem 
  \para \bf  Deletion in binary search trees.  \end 
  \header* fun/2 Delete 'Tex_f2_set_delete' \end Define the function 
  \ft Delete(t,x) \end such that 
  \eq* 
    Bst(t) -> Inbt(y,Delete(t,x)) <-> Inbt(y,t) & y != x
  \end
  \eq* 
    Bst(t) -> Bst Delete(t,x)
  \end

fun/2 Delete 'Tex_f2_set_delete'
  Delete(t,x) = Foo

